------------------------------------------------------
--(copy left) Arthur Øvergaard 
--Trondheim June 09
--
--Implements one digit recurrence stage to achieve final precision
------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.numeric_std.all;

entity round is
	port(
		approx_quot : in	std_logic_vector(63 downto 0);
		approx_rest : in	std_logic_vector(63 downto 0);
		divisor : in		std_logic_vector(63 downto 0);
		zero : in			std_logic;
		reset : in std_logic;
		
		quotient : out		std_logic_vector(63 downto 0);
		rest : out			std_logic_vector(63 downto 0));
end round;

architecture behavior of round is

begin
	process(approx_quot, approx_rest, divisor, zero, reset)
		variable diff : std_logic_vector(64 downto 0);
	begin
		diff := ('0' & approx_rest) - ('0' & divisor);--implements one subtraction, and saves the carry out for copmarison 
		
		if zero = '1' or reset = '1' then--If division by zero then set output to zero
			quotient <= (others => '0');
			rest <= (others => '0');
		elsif diff(diff'high) = '0' then--approx_rest >= divisor
			quotient <= approx_quot + '1';
			rest <= diff(63 downto 0);
		else
			quotient <= approx_quot;
			rest <= approx_rest;
		end if;
		
	end process;
end behavior;
			

