------------------------------------------------------
--(copy left) Arthur Øvergaard 
--Trondheim June 09
--
--Test bench used to test one Newton-Rahson stage
------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.numeric_std.all;

entity tb_NR_stage is
end tb_NR_stage;

architecture behavior of tb_NR_stage is
	
	constant periode : time := 10 ns;
	
	constant tb_input_precicion : integer := 8;
	

	component NR_stage is
		generic(
			input_presicion : integer := 4;
			pipe_stages : integer := 2);
		port(
			divisor :			in std_logic_vector(63 downto 0);
			resiprocal_in :		in std_logic_vector(input_presicion - 1 downto 0);
			enable :			in std_logic;
			clock :				in std_logic;
		
			resiprocal_out :	out std_logic_vector((input_presicion * 2) - 1 downto 0));
	end component;

	signal tb_divisor_norm_in :	std_logic_vector(63 downto 0) := (others => '0');
	signal tb_resiprocal_in :	std_logic_vector(tb_input_precicion - 1 downto 0) := (others => '0');
	signal tb_enable :			std_logic := '0';
	signal tb_clock :			std_logic := '0';

	signal tb_resiprocal_out :	std_logic_vector((tb_input_precicion*2) - 1 downto 0) := (others => '0');
	
begin


	dut:NR_stage
		generic map(tb_input_precicion, 2)
		port map(
			tb_divisor_norm_in,
			tb_resiprocal_in,
			tb_enable,
			tb_clock,
			
			tb_resiprocal_out);
			
	clocking:process
	begin
		wait for periode/2;
		tb_clock <= not(tb_clock);
	end process;
	
	data:process
		variable divd, divs : std_logic_vector(63 downto 0);
	begin
		wait until tb_clock'event and tb_clock = '1';
		
		tb_enable <= '1';
		
		wait until tb_clock'event and tb_clock = '1';
		
		divs := (others => '0');
		divs(divs'high) := '1';
		divs(divs'high-1) := '1';
		
		tb_divisor_norm_in <= divs;
		tb_resiprocal_in <= "10101010";
		
		
		wait until tb_clock'event and tb_clock = '1';
		
		tb_divisor_norm_in <= (others => '0');
		tb_resiprocal_in <= "00000000";
		
		wait;
	end process;
			
end behavior;
