------------------------------------------------------
--(copy left) Arthur Øvergaard 
--Trondheim June 09
--
--Test bench used to test the normaization circuit
------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use IEEE.numeric_std.all;

entity tb_norm_shifter is
end tb_norm_shifter;

architecture behavior of tb_norm_shifter is
	
	constant periode : time := 10 ns;
	
	component norm_shifter is
		generic(pipe_stages :	integer := 4);
		 port ( 
			dividend_in :	in std_logic_vector(63 downto 0);
			divisor_in :	in std_logic_vector(63 downto 0);
			enable :		in std_logic;
			clock :			in std_logic;
		
			divisor_norm : 	out	std_logic_vector(63 downto 0);
			dividend_out :	out std_logic_vector(63 downto 0);
			divisor_out :	out std_logic_vector(63 downto 0);
			count : 		out	integer range 0 to 63);
	end component;

	signal tb_dividend_in :		std_logic_vector(63 downto 0) := (others => '0');
	signal tb_divisor_in :		std_logic_vector(63 downto 0) := (others => '0');
	signal tb_enable :			std_logic := '0';
	signal tb_clock :			std_logic := '0';

	signal tb_divisor_norm : 	std_logic_vector(63 downto 0) := (others => '0');
	signal tb_dividend_out :	std_logic_vector(63 downto 0) := (others => '0');
	signal tb_divisor_out :		std_logic_vector(63 downto 0) := (others => '0');
	signal tb_count : 			integer range 0 to 63;
	
begin


	dut:norm_shifter
		generic map(4)
		port map(
			tb_dividend_in,
			tb_divisor_in,
			tb_enable,
			tb_clock,

			tb_divisor_norm,
			tb_dividend_out,
			tb_divisor_out,
			tb_count);
			
	clock:process
	begin
		wait for periode/2;
		tb_clock <= not(tb_clock);
	end process;
	
	data:process
		variable divd, divs : std_logic_vector(63 downto 0);
	begin
		wait until tb_clock'event and tb_clock = '1';
		
		tb_enable <= '1';
		
		wait until tb_clock'event and tb_clock = '1';
		
		divd := (others => '0');
		divd(0) := '1';
		divs := (others => '0');
		divs(0) := '1';
		
		tb_dividend_in <= divd;
		tb_divisor_in <= divs;
		
		
		wait until tb_clock'event and tb_clock = '1';
		
		--divd := (others => '0');
		divd(1) := '1';
		--divs := (others => '0');
		divs(4) := '1';
		
		tb_dividend_in <= divd;
		tb_divisor_in <= divs;
		
		wait until tb_clock'event and tb_clock = '1';
		
		--divd := (others => '0');
		divd(1) := '1';
		--divs := (others => '0');
		divs(63) := '1';
		
		tb_dividend_in <= divd;
		tb_divisor_in <= divs;
		
		wait;
	end process;
			
end behavior;
	
